%global realname eleveldb
%global upstream basho


Name:		erlang-%{realname}
Version:	2.2.19
Release:	4%{?dist}
Summary:	Erlang LevelDB API
Group:		Development/Languages
License:	ASL 2.0
URL:		https://github.com/%{upstream}/%{realname}
%if 0%{?el7}%{?fedora}
VCS:		scm:git:https://github.com/%{upstream}/%{realname}.git
%endif
Source0:	https://github.com/%{upstream}/%{realname}/archive/%{version}/%{realname}-%{version}.tar.gz
Source1:	https://github.com/basho/leveldb/archive/2.0.19/basho-leveldb-2.0.19.tar.gz
# Fedora/EPEL-specific
Patch1:		erlang-eleveldb-0001-Don-t-use-deprecated-erlang-now-0.patch
Patch2:		erlang-eleveldb-0002-Use-system-wide-snappy.patch
Patch3:		erlang-eleveldb-0003-Don-t-use-size_t-for-memory_sz-as-it-causes-warnings.patch
Patch4:		erlang-eleveldb-0004-Fix-deprecation-warning-while-building-with-Erlang-1.patch
# switch to <atomic> from non-standard <cstdatomic>
# https://github.com/basho/leveldb/pull/194
Patch100:	erlang-eleveldb-atomic.patch
BuildRequires:	erlang-cuttlefish
BuildRequires:	erlang-rebar
BuildRequires:	erlang-os_mon
#BuildRequires:	leveldb-devel
# Requires for using ps utility in tests
BuildRequires:	procps-ng
BuildRequires:	snappy-devel
%{?__erlang_nif_version:Requires: %{__erlang_nif_version}}


%description
Erlang LevelDB API.


%prep
%setup -q -n %{realname}-%{version}
rm -f c_src/build_deps.sh
rm -f c_src/snappy-1.0.4.tar.gz
%patch1 -p1 -b .remove_deprecated
%patch2 -p1 -b .use_systemwide
%patch3 -p1 -b .32_bit
%patch4 -p1 -b .remove_deprecated_erl_19
tar xvf %{SOURCE1}
%patch100 -p1 -b .atomic


%build
# Building Basho's leveldb fork first
cd leveldb-2.0.19
OPT="%{optflags}" make
cd -

%{erlang_compile}


%install
%{erlang_install}

install -p -m 0644 priv/eleveldb.schema %{buildroot}%{erlang_appdir}/priv
install -p -m 0644 priv/eleveldb_multi.schema %{buildroot}%{erlang_appdir}/priv


%check
%{erlang_test}


%files
%doc README.md
%{erlang_appdir}/


%changelog
* Tue Aug 16 2016 Peter Lemenkov <lemenkov@gmail.com> - 2.2.19-4
- Fix FTBFS with Erlang 19

* Sun Aug 07 2016 Igor Gnatenko <ignatenko@redhat.com> - 2.2.19-3
- Rebuild for Erlang 19

* Fri Jun 03 2016 Dan Horák <dan[at]danny.cz> - 2.2.19-2
- Fix build on secondary arches (#1340829)

* Sat May 21 2016 Peter Lemenkov <lemenkov@gmail.com> - 2.2.19-1
- Ver. 2.2.19

* Sat May 14 2016 Peter Lemenkov <lemenkov@gmail.com> - 2.2.18-2
- Install schemas

* Wed May 11 2016 Peter Lemenkov <lemenkov@gmail.com> - 2.2.18-1
- Ver. 2.2.18

* Fri Apr 15 2016 Peter Lemenkov <lemenkov@gmail.com> - 2.2.17-2
- Drop unneeded macro

* Fri Apr 15 2016 Peter Lemenkov <lemenkov@gmail.com> - 2.2.17-1
- Ver. 2.2.17
- Use Basho's leveldb fork

* Wed Mar 30 2016 Peter Lemenkov <lemenkov@gmail.com> - 1.3.2-11
- Rebuild with Erlang 18.3

* Fri Feb 12 2016 Peter Lemenkov <lemenkov@gmail.com> - 1.3.2-10
- Fixed FTBFS in Rawhide

* Wed Feb 03 2016 Fedora Release Engineering <releng@fedoraproject.org> - 1.3.2-9
- Rebuilt for https://fedoraproject.org/wiki/Fedora_24_Mass_Rebuild

* Wed Jun 17 2015 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 1.3.2-8
- Rebuilt for https://fedoraproject.org/wiki/Fedora_23_Mass_Rebuild

* Tue Nov 04 2014 Peter Lemenkov <lemenkov@gmail.com> - 1.3.2-7
- Rebuild with Erlang 17.3.3

* Thu Aug 28 2014 Peter Lemenkov <lemenkov@gmail.com> - 1.3.2-6
- Rebuild with Erlang 17.2.1

* Sat Aug 16 2014 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 1.3.2-5
- Rebuilt for https://fedoraproject.org/wiki/Fedora_21_22_Mass_Rebuild

* Sat Jul 12 2014 Ville Skyttä <ville.skytta@iki.fi> - 1.3.2-4
- Use new erlang macros to build with $RPM_OPT/LD_FLAGS etc, verbosely
- Disable cache leak test on F-20, F-21, and F-22 (#1107767, #1106223)

* Sat Jun 07 2014 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 1.3.2-3
- Rebuilt for https://fedoraproject.org/wiki/Fedora_21_Mass_Rebuild

* Sat Aug 03 2013 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 1.3.2-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_20_Mass_Rebuild

* Wed Jul 03 2013 Peter Lemenkov <lemenkov@gmail.com> - 1.3.2-1
- Ver. 1.3.2

* Tue Apr 02 2013 Dan Horák <dan[at]danny.cz> - 1.3.0-2
- fix build on s390

* Mon Mar 11 2013 Peter Lemenkov <lemenkov@gmail.com> - 1.3.0-1
- Ver. 1.3.0

* Wed Feb 13 2013 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 1.2.2-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_19_Mass_Rebuild

* Thu Oct 11 2012 Peter Lemenkov <lemenkov@gmail.com> - 1.2.2-1
- Ver. 1.2.2

* Wed Jul 18 2012 Peter Lemenkov <lemenkov@gmail.com> - 1.1.0-2
- Remove EL5-specific stuff from spec-file
- Enable tests

* Thu May 17 2012 Peter Lemenkov <lemenkov@gmail.com> - 1.1.0-1
- Ver. 1.1.0

* Fri Sep 16 2011 Peter Lemenkov <lemenkov@gmail.com> - 1.0.0-1
- Ver. 1.0.0
